---
title: Complete a multipart upload of a test file
description: Datadog, the leading service for cloud-scale monitoring.
breadcrumbs: Docs > API Reference > Synthetics
---

# Complete a multipart upload of a test file{% #complete-a-multipart-upload-of-a-test-file %}
Copy pageCopied
{% tab title="v2" %}

| Datadog site      | API endpoint                                                                                           |
| ----------------- | ------------------------------------------------------------------------------------------------------ |
| ap1.datadoghq.com | POST https://api.ap1.datadoghq.com/api/v2/synthetics/tests/{public_id}/files/multipart-upload-complete |
| ap2.datadoghq.com | POST https://api.ap2.datadoghq.com/api/v2/synthetics/tests/{public_id}/files/multipart-upload-complete |
| app.datadoghq.eu  | POST https://api.datadoghq.eu/api/v2/synthetics/tests/{public_id}/files/multipart-upload-complete      |
| app.ddog-gov.com  | POST https://api.ddog-gov.com/api/v2/synthetics/tests/{public_id}/files/multipart-upload-complete      |
| us2.ddog-gov.com  | POST https://api.us2.ddog-gov.com/api/v2/synthetics/tests/{public_id}/files/multipart-upload-complete  |
| app.datadoghq.com | POST https://api.datadoghq.com/api/v2/synthetics/tests/{public_id}/files/multipart-upload-complete     |
| us3.datadoghq.com | POST https://api.us3.datadoghq.com/api/v2/synthetics/tests/{public_id}/files/multipart-upload-complete |
| us5.datadoghq.com | POST https://api.us5.datadoghq.com/api/v2/synthetics/tests/{public_id}/files/multipart-upload-complete |

### Overview

Complete a multipart file upload for a Synthetic test. Call this endpoint after all parts have been uploaded using the presigned URLs obtained from the multipart presigned URLs endpoint. This endpoint requires any of the following permissions:
`synthetics_write``synthetics_create_edit_trigger` 


OAuth apps require the `synthetics_write` authorization [scope](https://docs.datadoghq.com/api/latest/scopes.md#synthetics) to access this endpoint.



### Arguments

#### Path Parameters

| Name                        | Type   | Description                          |
| --------------------------- | ------ | ------------------------------------ |
| public_id [*required*] | string | The public ID of the Synthetic test. |

### Request

#### Body Data (required)



{% tab title="Model" %}

| Parent field | Field                        | Type     | Description                                                         |
| ------------ | ---------------------------- | -------- | ------------------------------------------------------------------- |
|              | key [*required*]        | string   | The full storage path for the uploaded file.                        |
|              | parts [*required*]      | [object] | Array of completed parts with their ETags.                          |
| parts        | ETag [*required*]       | string   | The ETag returned by the storage provider after uploading the part. |
| parts        | PartNumber [*required*] | int64    | The 1-indexed part number for the multipart upload.                 |
|              | uploadId [*required*]   | string   | The upload ID returned when the multipart upload was initiated.     |

{% /tab %}

{% tab title="Example" %}

```json
{
  "key": "org-123/api-upload-file/abc-def-123/2024-01-01T00:00:00_uuid.json",
  "parts": [
    {
      "ETag": "\"d41d8cd98f00b204e9800998ecf8427e\"",
      "PartNumber": 1
    }
  ],
  "uploadId": "upload-id-abc123"
}
```

{% /tab %}

### Response

{% tab title="204" %}
No Content
{% /tab %}

{% tab title="400" %}
API error response.
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="403" %}
Forbidden.
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="404" %}
API error response.
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="429" %}
Too many requests
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

### Code Example

##### 
                  \## default
# 
 \# Path parameters export public_id="abc-def-123" \# Curl command curl -X POST "https://api.datadoghq.com/api/v2/synthetics/tests/${public_id}/files/multipart-upload-complete" \
-H "Content-Type: application/json" \
-H "DD-API-KEY: ${DD_API_KEY}" \
-H "DD-APPLICATION-KEY: ${DD_APP_KEY}" \
-d @- << EOF
{
  "key": "org-123/api-upload-file/abc-def-123/2024-01-01T00:00:00_uuid.json",
  "parts": [
    {
      "ETag": "\"d41d8cd98f00b204e9800998ecf8427e\"",
      "PartNumber": 1
    }
  ],
  "uploadId": "upload-id-abc123"
}
EOF 
                
##### 

```python
"""
Complete a multipart upload of a test file returns "No Content" response
"""

from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.synthetics_api import SyntheticsApi
from datadog_api_client.v2.model.synthetics_test_file_complete_multipart_upload_part import (
    SyntheticsTestFileCompleteMultipartUploadPart,
)
from datadog_api_client.v2.model.synthetics_test_file_complete_multipart_upload_request import (
    SyntheticsTestFileCompleteMultipartUploadRequest,
)

body = SyntheticsTestFileCompleteMultipartUploadRequest(
    key="org-123/api-upload-file/abc-def-123/2024-01-01T00:00:00_uuid.json",
    parts=[
        SyntheticsTestFileCompleteMultipartUploadPart(
            e_tag='"d41d8cd98f00b204e9800998ecf8427e"',
            part_number=1,
        ),
    ],
    upload_id="upload-id-abc123",
)

configuration = Configuration()
with ApiClient(configuration) as api_client:
    api_instance = SyntheticsApi(api_client)
    api_instance.complete_test_file_multipart_upload(public_id="abc-def-123", body=body)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=python) and then save the example to `example.py` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" python3 "example.py"
##### 

```ruby
# Complete a multipart upload of a test file returns "No Content" response

require "datadog_api_client"
api_instance = DatadogAPIClient::V2::SyntheticsAPI.new

body = DatadogAPIClient::V2::SyntheticsTestFileCompleteMultipartUploadRequest.new({
  key: "org-123/api-upload-file/abc-def-123/2024-01-01T00:00:00_uuid.json",
  parts: [
    DatadogAPIClient::V2::SyntheticsTestFileCompleteMultipartUploadPart.new({
      e_tag: '"d41d8cd98f00b204e9800998ecf8427e"',
      part_number: 1,
    }),
  ],
  upload_id: "upload-id-abc123",
})
api_instance.complete_test_file_multipart_upload("abc-def-123", body)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=ruby) and then save the example to `example.rb` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" rb "example.rb"
##### 

```go
// Complete a multipart upload of a test file returns "No Content" response

package main

import (
	"context"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
)

func main() {
	body := datadogV2.SyntheticsTestFileCompleteMultipartUploadRequest{
		Key: "org-123/api-upload-file/abc-def-123/2024-01-01T00:00:00_uuid.json",
		Parts: []datadogV2.SyntheticsTestFileCompleteMultipartUploadPart{
			{
				ETag:       `"d41d8cd98f00b204e9800998ecf8427e"`,
				PartNumber: 1,
			},
		},
		UploadId: "upload-id-abc123",
	}
	ctx := datadog.NewDefaultContext(context.Background())
	configuration := datadog.NewConfiguration()
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewSyntheticsApi(apiClient)
	r, err := api.CompleteTestFileMultipartUpload(ctx, "abc-def-123", body)

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `SyntheticsApi.CompleteTestFileMultipartUpload`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=go) and then save the example to `main.go` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" go run "main.go"
##### 

```java
// Complete a multipart upload of a test file returns "No Content" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.SyntheticsApi;
import com.datadog.api.client.v2.model.SyntheticsTestFileCompleteMultipartUploadPart;
import com.datadog.api.client.v2.model.SyntheticsTestFileCompleteMultipartUploadRequest;
import java.util.Collections;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    SyntheticsApi apiInstance = new SyntheticsApi(defaultClient);

    SyntheticsTestFileCompleteMultipartUploadRequest body =
        new SyntheticsTestFileCompleteMultipartUploadRequest()
            .key("org-123/api-upload-file/abc-def-123/2024-01-01T00:00:00_uuid.json")
            .parts(
                Collections.singletonList(
                    new SyntheticsTestFileCompleteMultipartUploadPart()
                        .eTag("""
"d41d8cd98f00b204e9800998ecf8427e"
""")
                        .partNumber(1L)))
            .uploadId("upload-id-abc123");

    try {
      apiInstance.completeTestFileMultipartUpload("abc-def-123", body);
    } catch (ApiException e) {
      System.err.println("Exception when calling SyntheticsApi#completeTestFileMultipartUpload");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=java) and then save the example to `Example.java` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" java "Example.java"
##### 

```rust
// Complete a multipart upload of a test file returns "No Content" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_synthetics::SyntheticsAPI;
use datadog_api_client::datadogV2::model::SyntheticsTestFileCompleteMultipartUploadPart;
use datadog_api_client::datadogV2::model::SyntheticsTestFileCompleteMultipartUploadRequest;

#[tokio::main]
async fn main() {
    let body = SyntheticsTestFileCompleteMultipartUploadRequest::new(
        "org-123/api-upload-file/abc-def-123/2024-01-01T00:00:00_uuid.json".to_string(),
        vec![SyntheticsTestFileCompleteMultipartUploadPart::new(
            r#""d41d8cd98f00b204e9800998ecf8427e""#.to_string(),
            1,
        )],
        "upload-id-abc123".to_string(),
    );
    let configuration = datadog::Configuration::new();
    let api = SyntheticsAPI::with_config(configuration);
    let resp = api
        .complete_test_file_multipart_upload("abc-def-123".to_string(), body)
        .await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=rust) and then save the example to `src/main.rs` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" cargo run
##### 

```typescript
/**
 * Complete a multipart upload of a test file returns "No Content" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration();
const apiInstance = new v2.SyntheticsApi(configuration);

const params: v2.SyntheticsApiCompleteTestFileMultipartUploadRequest = {
  body: {
    key: "org-123/api-upload-file/abc-def-123/2024-01-01T00:00:00_uuid.json",
    parts: [
      {
        eTag: `"d41d8cd98f00b204e9800998ecf8427e"`,
        partNumber: 1,
      },
    ],
    uploadId: "upload-id-abc123",
  },
  publicId: "abc-def-123",
};

apiInstance
  .completeTestFileMultipartUpload(params)
  .then((data: any) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=typescript) and then save the example to `example.ts` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" tsc "example.ts"
{% /tab %}
